# R.markDIY_1.7.5 by Takao Ishikawa, February 8th 2023 MIT license
rm(list = ls(all.names = TRUE))
# Read data, prepare directories, and rename answer sheets
dir.create(path = "./output")
dir.create(path = "./output/csv")
dir.create(path = "./output/png")
dir.create(path = "./output/report")
if ((file.exists("./input/Barcode_1.txt") && file.exists("./input/Barcode_2.txt"))==TRUE){
  # Combining answer sheets, needs "Barcode_1.txt" and "Barcode_2.txt" files from Barner software for macOS
  barcode_1 <- read.csv(file = "./input/Barcode_1.txt", sep = ";", header = F, stringsAsFactors = F, colClasses = "character")
  names(barcode_1) <- c("file name", "identification", "code")
  barcode_2 <- read.csv(file = "./input/Barcode_2.txt", sep = ";", header = F, stringsAsFactors = F, colClasses = "character")
  names(barcode_2) <- c("file name", "identification", "code")
  if (nrow(barcode_1)==nrow(barcode_2)){
    # Binding two answer sheets by file names
    answers_source_1.table <- read.csv(file = "./input/AnswerSheetDIY_1.csv", stringsAsFactors = F, header = F, colClasses = "character")
    n <- nrow(answers_source_1.table)
    y <- c(1:n)
    barcode_1_ordered <- barcode_1[order(barcode_1$code),]
    barcode_2_ordered <- barcode_2[order(barcode_2$code),]
    sheet_id.table <- cbind(barcode_1_ordered$code,barcode_1_ordered$`file name`,barcode_2_ordered$`file name`)
    barcode_bind.table <- matrix("", nrow = n, ncol = 4)
    barcode_bind.table[,1] <- answers_source_1.table[,2]
    barcode_bind.table[,3] <- answers_source_1.table[,1]
    for (j in y){
      barcode_bind.table[j,2] <- subset(sheet_id.table, sheet_id.table[,2] == barcode_bind.table[j,3])[1]
      barcode_bind.table[j,4] <- subset(sheet_id.table, sheet_id.table[,2] == barcode_bind.table[j,3])[3]
    }
    barcode_bind.table <- as.data.frame(barcode_bind.table)
    names(barcode_bind.table) <- c("album", "barcode", "sheet 1 file", "sheet 2 file")
    album_barcode_files.table <- barcode_bind.table[order(barcode_bind.table$album),]
    write.csv(album_barcode_files.table, file = "./output/csv/album_barcode_files.csv", row.names = F)
    # Readling answers from both answer sheets, both answer sheets should be scanned separately by AnswerSheetsDIY for macOS
    answers_source_1.table <- read.csv(file = "./input/AnswerSheetDIY_1.csv", stringsAsFactors = F, header = F, colClasses = "character")
    answers_source_2.table <- read.csv(file = "./input/AnswerSheetDIY_2.csv", stringsAsFactors = F, header = F, colClasses = "character")
    answers_source.table <- matrix("", nrow = nrow(barcode_bind.table), ncol = ((ncol(answers_source_1.table) - 1 + ncol(answers_source_2.table) - 1)))
    bar_n <- nrow(barcode_bind.table)
    bar_y <- c(1:bar_n)
    for (bar_j in bar_y){
      answers_source.table[bar_j,1] <- barcode_bind.table[bar_j,1]
      bar_row_1 <- subset(answers_source_1.table, answers_source_1.table[,1] == barcode_bind.table[bar_j,3])
      bar_row_2 <- subset(answers_source_2.table, answers_source_2.table[,1] == barcode_bind.table[bar_j,4])
      bar_row <- cbind(bar_row_1[2:length(bar_row_1)], bar_row_2[2:length(bar_row_2)])
      answers_source.table[bar_j,] <- as.matrix(bar_row)
    }
    answers.table <- answers_source.table
    m <- ncol(answers.table)
    r <- c(1:(m-1))
    s <- paste("Q", r)
    s_file <- paste("Q", r, sep = "")
    names(answers.table) <- c("album", s_file)
    template_source.table <- read.csv(file = "./input/AnswerSheetDIY_template.csv", stringsAsFactors = F, header = F, colClasses = "character")
    template_source.table[,1] <- NULL
    template.table <- template_source.table
    n <- nrow(answers.table)
    y <- c(1:n)
    dir.create(path = "./sheets/original/")
    dir.create(path = "./sheets/renamed/")
    for (j in y){
      #Sheet1
      file_old <- paste("./sheets/", barcode_bind.table[j,3], sep = "")
      file_renamed <- paste("./sheets/renamed/", barcode_bind.table[j,1], "_1.jpg", sep = "")
      file_original <- paste("./sheets/original/", barcode_bind.table[j,3], sep = "")
      file.copy(file_old, file_renamed) 
      file.copy(file_old, file_original)
      file.remove(paste("./sheets/", barcode_bind.table[j,3], sep = ""))
      #Sheet2
      file_old <- paste("./sheets/", barcode_bind.table[j,4], sep = "")
      file_renamed <- paste("./sheets/renamed/", barcode_bind.table[j,1], "_2.jpg", sep = "")
      file_original <- paste("./sheets/original/", barcode_bind.table[j,4], sep = "")
      file.copy(file_old, file_renamed) 
      file.copy(file_old, file_original)
      file.remove(paste("./sheets/", barcode_bind.table[j,4], sep = ""))
    }
  }else{
    print("Different numbers of sheets!")
  }
}else if (file.exists("./input/Barcode.txt")==TRUE){
  #Barcode information read with Barner for macOS
  answers_source.table <- read.csv(file = "./input/AnswerSheetDIY.csv", stringsAsFactors = F, header = F, colClasses = "character")
  template_source.table <- read.csv(file = "./input/AnswerSheetDIY_template.csv", stringsAsFactors = F, header = F, colClasses = "character")
  barcode <- read.csv(file = "./input/Barcode.txt", sep = ";", header = F, stringsAsFactors = F, colClasses = "character")
  n <- nrow(answers_source.table)
  y <- c(1:n)
  file_album.table <- answers_source.table[1:n,1:2]
  barcode_no <- rep(0,  n)
  album_barcode_file.table <- as.matrix(cbind(file_album.table[,2], barcode_no, file_album.table[,1]))
  bar_n <- nrow(barcode)
  bar_y <- c(1:bar_n)
  for (bar_j in bar_y){
    barcode_no <- 0
    barcode_no <- subset(barcode, barcode[,1] == file_album.table[bar_j,1])
    album_barcode_file.table[bar_j,2] <- barcode_no[,3]
  }
  album_barcode_file.table <- album_barcode_file.table[order(album_barcode_file.table[,1]),]
  colnames(album_barcode_file.table) <- c("album", "barcode", "original file name")
  write.csv(album_barcode_file.table, file = "./output/csv/album_barcode_file.csv", quote = F)
  dir.create(path = "./sheets/original/")
  dir.create(path = "./sheets/renamed/")
  for (j in y){
    file_old <- paste("./sheets/", file_album.table[j,1], sep = "")
    file_renamed <- paste("./sheets/renamed/", file_album.table[j,2], "_1.jpg", sep = "")
    file_original <- paste("./sheets/original/", file_album.table[j,1], sep = "")
    file.copy(file_old, file_renamed) 
    file.copy(file_old, file_original)
    file.remove(paste("./sheets/", file_album.table[j,1], sep = ""))
  }
  answers_source.table[,1] <- NULL 
  answers.table <- answers_source.table
  m <- ncol(answers.table)
  r <- c(1:(m-1))
  s <- paste("Q", r)
  s_file <- paste("Q", r, sep = "")
  names(answers.table) <- c("album", s_file)
  template_source.table[,1] <- NULL
  template.table <- template_source.table
}else{
  #No information on barcodes 
  answers_source.table <- read.csv(file = "./input/AnswerSheetDIY.csv", stringsAsFactors = F, header = F, colClasses = "character")
  template_source.table <- read.csv(file = "./input/AnswerSheetDIY_template.csv", stringsAsFactors = F, header = F, colClasses = "character")
  n <- nrow(answers_source.table)
  y <- c(1:n)
  file_album.table <- answers_source.table[1:n,1:2]
  album_file.table <- cbind(file_album.table[,2], file_album.table[,1])
  colnames(album_file.table) <- c("album", "original file name")
  write.csv(album_file.table, file = "./output/csv/album_file.csv", row.names = F, quote = F)
  dir.create(path = "./sheets/original/")
  dir.create(path = "./sheets/renamed/")
  for (j in y){
    file_old <- paste("./sheets/", file_album.table[j,1], sep = "")
    file_renamed <- paste("./sheets/renamed/", file_album.table[j,2], "_1.jpg", sep = "")
    file_original <- paste("./sheets/original/", file_album.table[j,1], sep = "")
    file.copy(file_old, file_renamed) 
    file.copy(file_old, file_original)
    file.remove(paste("./sheets/", file_album.table[j,1], sep = ""))
  }
  answers_source.table[,1] <- NULL 
  answers.table <- answers_source.table
  m <- ncol(answers.table)
  r <- c(1:(m-1))
  s <- paste("Q", r)
  s_file <- paste("Q", r, sep = "")
  names(answers.table) <- c("album", s_file)
  template_source.table[,1] <- NULL
  template.table <- template_source.table
}
# Re-order data according to version
if (file.exists("./input/QuestionOrder.csv")==TRUE){
  n <- nrow(answers.table)
  m <- ncol(answers.table)
  y <- 1:n
  x <- 2:m
  answers_reordered.table <- answers.table
  q_order.table <- read.csv(file = "./input/QuestionOrder.csv", stringsAsFactors = F, header = F, colClasses = "character")
  qn <- nrow(q_order.table)
  qm <- ncol(q_order.table)
  if (qn >= 2){
    qy <- 2:qn
    qx <- 2:qm
    for (j in y){
      version <- answers.table[j,m]
      for (qj in qy){
        q_order <- subset(q_order.table, q_order.table[,1]==version)
        for (qi in qx){
          qpat <- paste("^", q_order.table[1,qi], "$", sep = "")
          qpos <- grep(qpat, q_order)
          answers_reordered.table[j,qi] <- answers.table[j,qpos]
        }
      }
    }  
    answers_reordered.table[,m] <- NULL
    answers.table <- answers_reordered.table
    m <- ncol(answers.table)
    r <- c(1:(m-1))
    s <- paste("Q", r)
    s_file <- paste("Q", r, sep = "")
    names(answers.table) <- c("album", s_file)
  }
}
# Absence check
if (file.exists("./input/USOS_list.csv")==TRUE){
  n <- nrow(answers.table)
  read_album <- sort(as.character(answers.table[,1]))
  usos <- read.csv(file = "./input/USOS_list.csv", sep = ";", header = F, stringsAsFactors = F, colClasses = "character")
  usos_album <- usos[,1]
  usos_album <- sort(usos_album)
  usos_album <- usos_album[1:(length(usos_album)-1)]
  absence <- as.data.frame(setdiff(usos_album, read_album))
  names(absence) <- c("album")
  write.csv(absence, file = "./output/csv/absense_id.csv", row.names = F)
}
# Number of students and questions
n <- nrow(answers.table)
m <- ncol(answers.table)
y <- 1:n
x <- 2:m
# Collect data
results.table <- answers.table
for (j in y){
  for (i in x){
    results.table[j,i] <- (as.logical(template.table[1,i] == answers.table[j,i]))
    if (results.table[j,i] == TRUE) {
      results.table[j,i] <- 1
    } else {
      results.table[j,i] <- 0
    }
  }
}
# Calculate final scores
score.table <- matrix(0, nrow=n, ncol=3)
for (j in y){
  x <- sum(as.numeric(unlist(results.table[j,2:m])))
  score.table[j,1] <- as.character(answers.table[j,1])
  score.table[j,2] <- as.numeric(x)
  score.table[j,3] <- as.numeric(round(x / (m - 1) * 100, digits = 1))
}
write.table(score.table, file = "./output/csv/score_raw.csv", col.names=F, row.names = F, quote=F, append=F, sep = ",")
write.table(answers.table, file = "./output/csv/answers_raw.csv", col.names=F, row.names = F, quote=F, append=F, sep = ",")
# Data analysis
n <- nrow(answers.table)
m <- ncol(answers.table)
y <- 1:n
x <- 2:m
help.table <- matrix(nrow=1, ncol=m)
p <- round(as.numeric(n/2))
q <- as.numeric(p+1)
u <- c("ID", "Sum", "Correct%")
discrimination.table <- data.frame(score.table, stringsAsFactors=FALSE)
names(discrimination.table) <- c(u)
discrimination.table$ID <- as.numeric(as.character(discrimination.table$ID))
discrimination.table$Sum <- as.numeric(as.character(discrimination.table$Sum))
discrimination.table <- discrimination.table[order(discrimination.table$Sum, decreasing = T),]
sorted_results.table <- cbind(results.table, as.numeric(score.table[,2]))
sorted_results.table <- sorted_results.table[order(sorted_results.table[,m+1], decreasing = T),]
parameters.table <- matrix("", nrow=12, ncol=m)
parameters.table[1:12,1] <- c("easiness", "difficulty", "easiness", "discrimination", "discrimination", "omission", "mean", "mode", "median", "range", "S.D.", "Kuder-Richardson-20")
for (i in x){
  parameters.table[1,i] <- round(sum(as.numeric(results.table[,i])) / n, digits = 2)
  parameters.table[2,i] <- 1 - as.numeric(parameters.table[1,i])
  help.table[1,i] <- as.numeric(parameters.table[1,i]) * as.numeric(parameters.table[2,i])
  if (parameters.table[1,i] >=0.9){
    parameters.table[3,i] <- c("very easy")
  } else if (parameters.table[1,i] < 0.9 && parameters.table[1,i] >= 0.7){
    parameters.table[3,i] <- c("easy")
  } else if (parameters.table[1,i] < 0.7 && parameters.table[1,i] >= 0.5){
    parameters.table[3,i] <- c("moderate")
  } else if (parameters.table[1,i] < 0.5 && parameters.table[1,i] >= 0.2){
    parameters.table[3,i] <- c("difficult")
  } else {
    parameters.table[3,i] <- c("very difficult")
  }
  parameters.table[4,i] <- round((sum(as.numeric(sorted_results.table[1:p, as.numeric(i)])) - sum(as.numeric(sorted_results.table[q:n, as.numeric(i)]))) / (0.5*n), digits = 2)
  if (parameters.table[4,i] >=0.4){
    parameters.table[5,i] <- c("sufficient")
  } else if (parameters.table[4,i] < 0.4 && parameters.table[4,i] >= 0.3){
    parameters.table[5,i] <- c("moderate")
  } else if (parameters.table[4,i] < 0.3 && parameters.table[4,i] >= 0.2){
    parameters.table[5,i] <- c("marginal")
  } else {
    parameters.table[5,i] <- c("useless")
  }
  parameters.table[6,i] <- round(as.numeric(length(which(answers.table[,i] == "")) / n), digits = 2)
}
parameters.table[7,2] <- round(mean(as.numeric(score.table[,2])), digits = 2)
parameters.table[8,2] <- names(which.max(table(score.table[,2])))
parameters.table[9,2] <- round(median(as.numeric(score.table[,2])), digits = 2)
parameters.table[10,2] <- max(as.numeric(score.table[,2])) - min(as.numeric(score.table[,2]))
parameters.table[10,4] <- c("max")
parameters.table[10,5] <- max(as.numeric(score.table[,2]))
parameters.table[10,7] <- c("min")
parameters.table[10,8] <- min(as.numeric(score.table[,2]))
parameters.table[11,2] <- round(sd(as.numeric(score.table[,2])), digits = 3)
parameters.table[12,2] <- round(((m-1)/(m-2))*(1-(sum(as.numeric(help.table[1,2:m])))/(as.numeric(parameters.table[11,2])^2)), digits = 2)
if (parameters.table[12,2] >= 0.8){
  parameters.table[12,3] <- c("highly reliable")
} else if (parameters.table[12,2] < 0.8 && parameters.table[12,2] >= 0.5){
  parameters.table[12,3] <- c("reliable")
} else{
  parameters.table[12,3] <- c("not reliable")
}
# Data output
if (file.exists("./input/Grade.csv")==TRUE){
  grade <- read.csv(file = "./input/Grade.csv", stringsAsFactors = F, header = F, colClasses = "character")
  cols <- sort(as.numeric(unlist(labels(table(score.table[,2])))))
  border <- length(cols[cols < grade[5,2]])
  cols[1:(border)] <- c("red")
  cols[border+1:length(cols)] <- c("green")
  plot(table(as.numeric(score.table[,2])), main = "Results", xlab = "Sum of points", ylab = "Number of students", col = cols)
  png(filename = "./output/png/histogram.png", width = 40*m, height = 600)
  plot(table(as.numeric(score.table[,2])), main = "Results", xlab = "Sum of points", ylab = "Number of students", col = cols)
  dev.off()
}else{
  plot(table(as.numeric(score.table[,2])), main = "Results", xlab = "Sum of points", ylab = "Number of students", col = "gray")  
  png(filename = "./output/png/histogram.png", width = 40*m, height = 600)
  plot(table(as.numeric(score.table[,2])), main = "Results", xlab = "Sum of points", ylab = "Number of students", col = "gray")
  dev.off()
}
bar <- rbind(as.numeric(parameters.table[1,2:m]),as.numeric(parameters.table[4,2:m]))
rownames(bar) <- c("easiness", "discrimination")
r <- c(1:(m-1))
s <- paste("Q", r)
s_file <- paste("Q", r, sep = "")
t <- c("parameters", s)
png(filename = "./output/png/parameters.png", width = 60*m, height = 600)
barplot(bar, beside = T, legend = T, space = c(0,1), main = "Easiness and discrimination values", xlab = "Question number", ylab = "Frequency", names.arg = c(1:(m-1)))
dev.off()
png(filename = "./output/png/easiness.png", width = 40*m, height = 600)
barplot(bar[1,], main = "Easiness", xlab = "Question number", ylab = "Frequency", names.arg = c(1:(m-1)))
dev.off()
png(filename = "./output/png/discrimination.png", width = 40*m, height = 600)
barplot(bar[2,], main = "Discrimination", xlab = "Question number", ylab = "Frequency", names.arg = c(1:(m-1)))
dev.off()
parameters_header.table <- data.frame(parameters.table)
names(parameters_header.table) <- c(t)
write.table(parameters_header.table, file = "./output/csv/parameters.csv", col.names=T, row.names = F, quote=F, append=F, sep = ",")
v <- c("ID", "Sum", "Correct%", "Z-score")
z_score <- rep(0, nrow(discrimination.table))
discrimination.table <- cbind(discrimination.table, z_score)
dy <- c(1:nrow(discrimination.table))
for (i in dy){
  z_score <- (discrimination.table[i,2] - mean(discrimination.table$Sum))/sd(discrimination.table$Sum)
  discrimination.table[i,4] <- round(z_score, digits = 3)
}
score_sum_header.table <- discrimination.table
names(score_sum_header.table) <- c(v)
write.table(score_sum_header.table, file = "./output/csv/score_sum.csv", col.names=T, row.names = F, quote=F, append=F, sep = ",")
score_id_header.table <- discrimination.table[order(discrimination.table$ID, decreasing = F),]
names(score_id_header.table) <- c(v)
write.table(score_id_header.table, file = "./output/csv/score_id.csv", col.names=T, row.names = F, quote=F, append=F, sep = ",")
write.table(results.table, file = "./output/csv/results_raw.csv", col.names=F, row.names = F, quote=F, append=F, sep = ",")
# Answer distribution
n <- nrow(answers.table)
m <- ncol(answers.table)
y <- 1:n
x <- 2:m
distribution.table <- matrix("", nrow=2^6, ncol=m)
for (i in x){
  v <- as.character(answers.table[,i])
  tmp <- table(v)
  file_name <- paste("./output/png/dist_", s_file[i-1], ".png", sep = "")
  l <- 1:(length(tmp))
  xlab <- c("grey")
  for (k in l){
    tmp_label <- labels(tmp[k])
    tmp_value <- c(tmp[[k]])
    tmp_fraction <- round((tmp_value / n), digits = 2)
    e <- as.numeric(k*2)
    f <- e + 1
    distribution.table[e,i] <- tmp_label
    distribution.table[f,i] <- tmp_fraction
    if (tmp_label==template.table[1,i]){
      xlab[k] <- c("blue")
    } else {
      xlab[k] <- c("grey")
    }
    png(filename =  file_name, width = 640, height = 480)
    barplot(tmp, main = s[i-1], sub = paste("Easiness", parameters.table[1,i], paste("(", parameters.table[3,i], ")", sep = ""), "/", "Discrimination", parameters.table[4,i], paste("(", parameters.table[5,i], ")", sep = "")), col = xlab)
    dev.off()
  }
}
distribution.table <- as.data.frame(distribution.table, stringsAsFactors = F)
distribution.table[,1] <- NULL
distribution.table[1,] <- template.table[1,2:m]
names(distribution.table) <- c(s)
write.table(distribution.table, file = "./output/csv/distribution.csv", col.names=T, row.names = F, quote=F, append=F, sep = ",")
#Generating protocol for grading purposes
if (file.exists("./input/USOS_list.csv")==TRUE){
  protocol <- usos
  protocol[,2] <- usos[,3]
  protocol[,3] <- usos[,2]
  protocol[1,] <- c("album", "surname", "first name", "status", "score", "grade")
  a <- c(1:nrow(absence))
  for (i in a){
    abs_pos <- grep(absence[i,1], protocol[,1])
    protocol[(abs_pos),4] <- "absent"
    protocol[(abs_pos),5] <- "-"
    protocol[(abs_pos),6] <- ""
  }
  c <- c(1:nrow(answers_source.table))
  for (j in c){
    scn_pos <- grep(score.table[j,1], protocol[,1])
    protocol[(scn_pos),4] <- "scanned"
    protocol[(scn_pos),5] <- score.table[j,2]
    protocol[(scn_pos),6] <- ""
  }
  protocol[1,] <- NA
  protocol <- na.omit(protocol)
  names(protocol) <- c("album", "surname", "first name", "status", "score", "grade")
  no_usos_album <- setdiff(answers.table[,1], protocol$album)
  if ((as.numeric(length(no_usos_album)) > 0)==TRUE){
    no_usos <- c(1:length(no_usos_album))
    add_protocol <- matrix("", ncol = 6, nrow = length(no_usos_album))
    for (i in no_usos){
      add_protocol[i,1] <- subset(score_id_header.table, score_id_header.table$ID==no_usos_album[i])[1,1]
      add_protocol[i,5] <- subset(score_id_header.table, score_id_header.table$ID==no_usos_album[i])[1,2]
      add_protocol[i,4] <- "no usos"
      add_protocol[i,2] <- ""
      add_protocol[i,3] <- ""
      add_protocol[i,6] <- ""
    }
  add_protocol <- as.data.frame(add_protocol)
  names(add_protocol) <- c("album", "surname", "first name", "status", "score", "grade")
  protocol <- rbind(protocol, add_protocol)
  }
}
#Assign grades ("Grade.csv" file needed)
if (file.exists("./input/Grade.csv")==TRUE){
  grade <- read.csv(file = "./input/Grade.csv", stringsAsFactors = F, header = F, colClasses = "character")
  g <- c(1:nrow(protocol))
  for (i in g){
    if (protocol[i,5] == "-"){
      protocol[i,6] <- c("-")
    }else if (as.numeric(protocol[i,5]) >= grade[6,2] && as.numeric(protocol[i,5]) < grade[5,2]){
      protocol[i,6] <- grade[6,1]
    }else if (as.numeric(protocol[i,5]) >= grade[5,2] && as.numeric(protocol[i,5]) < grade[4,2]){
      protocol[i,6] <- grade[5,1]
    }else if (as.numeric(protocol[i,5]) >= grade[4,2] && as.numeric(protocol[i,5]) < grade[3,2]){
      protocol[i,6] <- grade[4,1]
    }else if (as.numeric(protocol[i,5]) >= grade[3,2] && as.numeric(protocol[i,5]) < grade[2,2]){
      protocol[i,6] <- grade[3,1]
    }else if (as.numeric(protocol[i,5]) >= grade[2,2] && as.numeric(protocol[i,5]) < grade[1,2]){
      protocol[i,6] <- grade[2,1]
    }else if (as.numeric(protocol[i,5]) >= grade[1,2]){
      protocol[i,6] <- grade[1,1]
    }else
      protocol[i,6] <- c("")
  }
}
#Generate USOS_list.csv for second term
if ((exists("protocol")&&exists("add_protocol"))==TRUE){
add_usos <- matrix("", ncol = 6, nrow = nrow(add_protocol))
add_usos <- as.data.frame(add_usos)
add_usos[,1] <- as.data.frame(add_protocol[,1])
sum_usos <- rbind(usos, add_usos)
if (file.exists("./input/Grade.csv")==TRUE){
  failed <- subset(protocol[,1], protocol[,6] == "2") 
  absent <- subset(protocol[,1], protocol[,6] == "-")
  wograde <- subset(protocol[,1], protocol[,6] == "")
  next_id <- c(failed, absent, wograde)
  e <- c(1:length(next_id))
  usos_next <- rbind(usos[1,],usos[2,])
  for (i in e){
    usos_next[(i+1),] <- subset(sum_usos, next_id[i] == sum_usos[,1])
  }
  usos_header <- usos_next[1,]
  usos_next[1,] <- NA
  usos_next <- na.omit(usos_next)
  usos_next <- usos_next[order(usos_next[,3]),]
  usos_next <- rbind(usos_header, usos_next)
  write.table(usos_next, file = "./output/csv/_next_USOS_list.csv", col.names=F, row.names = F, quote=F, append=F, sep = ";")
}
}
names(template.table) <- c("album", s_file)
#Generate HTML file with simple exam report
html <- c("")
html[1] <- "<html><meta charset=\"UTF-8\"><body><center>"
html[2] <- paste("<b>Exam parameters</b><br><table><tr><td>Mean</td><td>", parameters.table[7,2],  " / ", max(r),"</td></tr><tr><td>Mode</td><td>", parameters.table[8,2], "</td></tr><tr><td>Median</td><td>", parameters.table[9,2], "</td></tr><tr><td>Standard deviation</td><td>", parameters.table[11,2], "</td></tr><tr><td>Kuder-Richardson-20</td><td>", parameters.table[12,2], " (", parameters.table[12,3], ")</td></tr></table><br>", sep = "")    
html[3] <- "<img src=\"../png/histogram.png\"><br><hr>"
html[4] <- "<img src=\"../png/parameters.png\"><br><hr>"
for (i in r){
  html[i+4] <- paste("<img src=\"../png/dist_", s_file[i], ".png\"><br><hr>", sep="") 
}
html[i+5] <- "</center></body></html>"
write(html, file = "./output/report/report.html")
#Generate LaTeX file with exam report
latex <- c("")
latex[1] <- "\\documentclass[11pt,oneside,a4paper]{article}"
latex[2] <- "\\usepackage{graphicx}\\usepackage{caption}\\usepackage[polish]{babel}"
latex[3] <- "\\begin{document}"
latex[4] <- "\\title{Nazwa przedmiotu}"
latex[5] <- "\\date{Data egzaminu i termin}"
latex[6] <- "\\maketitle"
latex[7] <- "\\section{Parametry egzaminu}"
latex[8] <- paste("Maksymalna liczba punktów do uzyskania: ", max(r), "\\\\Średnia liczba punktów: ", parameters.table[7,2], " (", round(as.numeric(parameters.table[7,2])/max(r)*100, 1), "\\%)",  "\\\\Dominanta liczby punktów: ", parameters.table[8,2], " (", round(as.numeric(parameters.table[8,2])/max(r)*100, 1), "\\%)", "\\\\Mediana liczby punktów: ", parameters.table[9,2], " (", round(as.numeric(parameters.table[9,2])/max(r)*100, 1), "\\%)", "\\\\Minimalny wynik: ", parameters.table[10,8] ," (", round(as.numeric(parameters.table[10,8])/max(r)*100, 1), "\\%)", "\\\\Maksymalny wynik: ", parameters.table[10,5], " (", round(as.numeric(parameters.table[10,5])/max(r)*100, 1), "\\%)", "\\\\Odchylenie standardowe: ", parameters.table[11,2], "\\\\Parametr Kudera-Richardsona-20: ", parameters.table[12,2], " (egzamin był \\textit{", parameters.table[12,3], "})", sep = "")
if (file.exists("./input/Grade.csv")==TRUE){
  latex[9] <- paste("\\begin{figure}[h]\\centering\\includegraphics[width=9cm]{../png/histogram.png}\\caption*{Liczba puntów a ocena z egzaminu: 0–", grade[5,2]-1, ", ndst (2); ", grade[5,2], "–", grade[4,2]-1, ", dst (3); ", grade[4,2], "–", grade[3,2]-1, ", dst+ (3+); ",grade[3,2], "–", grade[2,2]-1, ", db (4); ", grade[2,2], "–", grade[1,2]-1, ", db+ (4+); ", grade[1,2], "–", max(r), ", bdb (5).", "}\\end{figure}\\newpage", sep = "")
}else{
  latex[9] <- "\\begin{figure}[h]\\centering\\includegraphics[width=9cm]{../png/histogram.png}\\caption*{Rozkład liczby punktów.}\\end{figure}\\newpage"
}
if (file.exists("./input/QuestionOrder.csv")==TRUE){
    latex[10] <- "\\section{Uwagi ogólne}\\begin{itemize}\\item Numeracja zadań jest zgodna z kolejnością zadań w wersji A egzaminu.\\item W zadaniach typu \\textit{prawda/fałsz} odpowiedzi na wykresach są wskazane jako A (\\textit{prawda}) lub B (\\textit{fałsz}).\\item Kolorem niebieskim na wykresach oznaczono prawidłową odpowiedź.\\item Pod wykresami umieszczono informację o łatwości zadania (jaki procent studentów odpowiedział prawidłowo) oraz mocy różnicującej zadania (jak dobrze korelował wybór właściwej odpowiedzi z ogólnym dobrym wynikiem z egzaminu).\\item Szczegółowy komentarz został umieszczony jedynie przy niektórych zadaniach.\\end{itemize}"
  }else{
    latex[10] <- "\\section{Uwagi ogólne}\\begin{itemize}\\item W zadaniach typu \\textit{prawda/fałsz} odpowiedzi na wykresach są wskazane jako A (\\textit{prawda}) lub B (\\textit{fałsz}).\\item Kolorem niebieskim na wykresach oznaczono prawidłową odpowiedź.\\item Pod wykresami umieszczono informację o łatwości zadania (jaki procent studentów odpowiedział prawidłowo) oraz mocy różnicującej zadania (jak dobrze korelował wybór właściwej odpowiedzi z ogólnym dobrym wynikiem z egzaminu).\\item Szczegółowy komentarz został umieszczony jedynie przy niektórych zadaniach.\\end{itemize}"
}
latex[11] <- "\\section{Rozkład odpowiedzi}"
for (i in r){
  latex[i+11] <- paste("\\paragraph{}\\begin{figure}[h]\\centering\\includegraphics[width=8cm]{../png/dist_", s_file[i], ".png}\\caption*{Komentarz do zadania ", i, ".: brak.}\\end{figure}", sep="") 
}
latex[i+12] <- "\\end{document}"  
write(latex, file = "./output/report/report.tex")
#Generate protocols for USOS
if (exists("protocol")==TRUE){
  write.table(protocol, file = "./output/csv/protocol.csv", col.names=T, row.names = F, quote=F, append=F, sep = ",") 
  usos_protocol <- protocol[c(1,2,3,6,4,5)]
  usos_protocol[,5:6] <- rep("", nrow(usos_protocol))
  usos_protocol <- cbind(usos_protocol, rep("", nrow(usos_protocol)), rep("", nrow(usos_protocol)))
  names(usos_protocol) <- c("usos_id","imie","nazwisko","zerówka","komentarz","komentarz dla studenta","pierwszy termin","kolejny komentarz")
  write.table(usos_protocol, file = "./output/csv/protocol_usos.csv", col.names=T, row.names = F, quote=F, append=F, sep = ";")
}
#S.D.G.